Index: /code/trunk/src/libraries/core/input/InputManager.h
===================================================================
--- /code/trunk/src/libraries/core/input/InputManager.h	(revision 6745)
+++ /code/trunk/src/libraries/core/input/InputManager.h	(revision 6746)
@@ -36,8 +36,9 @@
 #include <string>
 #include <vector>
+#include <boost/function.hpp>
 
 #include "util/Singleton.h"
+#include "util/TriBool.h"
 #include "core/WindowEventListener.h"
-#include "InputState.h"
 
 // tolua_begin
@@ -75,7 +76,5 @@
             Nothing       = 0x00,
             Bad           = 0x02,
-            Ticking       = 0x04,
-            Calibrating   = 0x08,
-            ReloadRequest = 0x10,
+            Calibrating   = 0x04,
         };
 
@@ -159,5 +158,5 @@
             - The removal process is being postponed if InputManager::preUpdate() is currently running.
         */
-        bool destroyState(const std::string& name);
+        bool destroyState(const std::string& name); // tolua_export
 
         //-------------------------------
@@ -169,5 +168,14 @@
         //! Returns a pointer to the OIS InputManager. Only you if you know what you're doing!
         OIS::InputManager* getOISInputManager() { return this->oisInputManager_; }
+        //! Returns the position of the cursor as std::pair of ints
         std::pair<int, int> getMousePosition() const;
+        //! Tells whether the mouse is used exclusively to the game
+        bool isMouseExclusive() const { return this->exclusiveMouse_; } // tolua_export
+
+        //-------------------------------
+        // Function call caching
+        //-------------------------------
+        void pushCall(const boost::function<void ()>& function)
+            { this->callBuffer_.push_back(function); }
 
         static InputManager& getInstance() { return Singleton<InputManager>::getInstance(); } // tolua_export
@@ -196,5 +204,5 @@
         OIS::InputManager*                  oisInputManager_;      //!< OIS input manager
         std::vector<InputDevice*>           devices_;              //!< List of all input devices (keyboard, mouse, joy sticks)
-        MouseMode::Value                    mouseMode_;            //!< Currently applied mouse mode
+        TriBool::Value                      exclusiveMouse_;       //!< Currently applied mouse mode
 
         // some internally handled states and handlers
@@ -207,7 +215,5 @@
         std::vector<InputState*>            activeStatesTicked_;   //!< Like activeStates_, but only contains the ones that currently receive events
 
-        std::set<InputState*>               stateEnterRequests_;   //!< Requests to enter a new state
-        std::set<InputState*>               stateLeaveRequests_;   //!< Requests to leave a running state
-        std::set<InputState*>               stateDestroyRequests_; //!< Requests to destroy a state
+        std::vector<boost::function<void ()> > callBuffer_;        //!< Caches all calls from InputStates to be executed afterwards (see preUpdate)
 
         static InputManager*                singletonPtr_s;        //!< Pointer reference to the singleton
Index: /code/trunk/src/libraries/core/input/InputPrereqs.h
===================================================================
--- /code/trunk/src/libraries/core/input/InputPrereqs.h	(revision 6745)
+++ /code/trunk/src/libraries/core/input/InputPrereqs.h	(revision 6746)
@@ -42,4 +42,5 @@
 #include <ois/OISMouse.h>
 #include <ois/OISJoyStick.h>
+#include "util/OrxEnum.h"
 
 namespace orxonox
@@ -448,4 +449,18 @@
         };
     }
+
+    //! Enumeration wrapper for input state priorities
+    struct InputStatePriority : OrxEnum<InputStatePriority>
+    {
+        OrxEnumConstructors(InputStatePriority);
+
+        static const int Empty        = -1;
+        static const int Dynamic      = 0;
+
+        static const int HighPriority = 1000;
+        static const int Console      = HighPriority + 0;
+        static const int Calibrator   = HighPriority + 1;
+        static const int Detector     = HighPriority + 2;
+    };
 }
 
Index: /code/trunk/src/libraries/core/input/InputState.cc
===================================================================
--- /code/trunk/src/libraries/core/input/InputState.cc	(revision 6745)
+++ /code/trunk/src/libraries/core/input/InputState.cc	(revision 6746)
@@ -37,5 +37,5 @@
         , bAlwaysGetsInput_(bAlwaysGetsInput)
         , bTransparent_(bTransparent)
-        , mouseMode_(MouseMode::Dontcare)
+        , exclusiveMouse_(TriBool::Dontcare)
         , bExpired_(true)
         , handlers_(2)
Index: /code/trunk/src/libraries/core/input/InputState.h
===================================================================
--- /code/trunk/src/libraries/core/input/InputState.h	(revision 6745)
+++ /code/trunk/src/libraries/core/input/InputState.h	(revision 6746)
@@ -35,35 +35,17 @@
 #include <string>
 #include <vector>
-
-#include "util/OrxEnum.h"
+#include <boost/function.hpp>
+#include <boost/bind.hpp>
+
+#include "util/TriBool.h"
 #include "InputHandler.h"
+#include "InputManager.h"
 #include "JoyStickQuantityListener.h"
+
+#define INPUT_STATE_PUSH_CALL(deviceIndex, functionName, ...) \
+    InputManager::getInstance().pushCall(boost::function<void ()>(boost::bind(&InputHandler::functionName, handlers_[deviceIndex], __VA_ARGS__)))
 
 namespace orxonox
 {
-    //! Enumeration wrapper for input state priorities
-    struct InputStatePriority : OrxEnum<InputStatePriority>
-    {
-        OrxEnumConstructors(InputStatePriority);
-
-        static const int Empty        = -1;
-        static const int Dynamic      = 0;
-
-        static const int HighPriority = 1000;
-        static const int Console      = HighPriority + 0;
-        static const int Calibrator   = HighPriority + 1;
-        static const int Detector     = HighPriority + 2;
-    };
-
-    namespace MouseMode
-    {
-        enum Value
-        {
-            Exclusive,
-            Nonexclusive,
-            Dontcare
-        };
-    }
-
     /**
     @brief
@@ -73,5 +55,5 @@
         that stack and only the top one gets the input events. This is done for
         every device (keyboard, mouse, all joy sticks) separately to allow
-        for intance keyboard input capturing for the console while you can still
+        for instance keyboard input capturing for the console while you can still
         steer a ship with the mouse.
         There are two exceptions to this behaviour though:
@@ -83,5 +65,5 @@
           the state will always receive input as long as it is activated.
         - Note: If you mark an InputState with both parameters on, then it will
-          not influence ony other InputState at all.
+          not influence only other InputState at all.
 
     @par Priorities
@@ -95,5 +77,5 @@
     @par Exclusive/Non-Exclusive mouse Mode
         You can select a specific mouse mode that tells whether the application
-        should have exclusive accessto it or not.
+        should have exclusive access to it or not.
         When in non-exclusive mode, you can move the mouse out of the window
         like with any other normal window (only for windowed mode!).
@@ -130,6 +112,6 @@
         void setHandler        (InputHandler* handler);
 
-        void setMouseMode(MouseMode::Value value) { mouseMode_ = value; this->bExpired_ = true; }
-        MouseMode::Value getMouseMode() const { return mouseMode_; }
+        void setMouseExclusive(TriBool::Value value) { exclusiveMouse_ = value; this->bExpired_ = true; }
+        TriBool::Value getMouseExclusive() const { return exclusiveMouse_; }
 
         //! Returns the name of the state (which is unique!)
@@ -152,6 +134,6 @@
 
         //! Generic function that distributes all 9 button events
-        template <typename EventType, class Traits>
-        void buttonEvent(unsigned int device, const typename Traits::ButtonTypeParam button);
+        template <typename EventType, class ButtonTypeParam>
+        void buttonEvent(unsigned int device, ButtonTypeParam button);
 
         //! Event handler
@@ -184,5 +166,5 @@
         const bool                  bAlwaysGetsInput_;      //!< See class declaration for explanation
         const bool                  bTransparent_;          //!< See class declaration for explanation
-        MouseMode::Value            mouseMode_;             //!< See class declaration for explanation
+        TriBool::Value              exclusiveMouse_;        //!< See class declaration for explanation
         int                         priority_;              //!< Current priority (might change)
         bool                        bExpired_;              //!< See hasExpired()
@@ -198,5 +180,5 @@
         for (unsigned int i = 0; i < handlers_.size(); ++i)
             if (handlers_[i] != NULL)
-                handlers_[i]->allDevicesUpdated(dt);
+                INPUT_STATE_PUSH_CALL(i, allDevicesUpdated, dt);
     }
 
@@ -207,25 +189,29 @@
         case InputDeviceEnumerator::Keyboard:
             if (handlers_[keyboardIndex_s] != NULL)
-                handlers_[keyboardIndex_s]->keyboardUpdated(dt);
+                INPUT_STATE_PUSH_CALL(keyboardIndex_s, keyboardUpdated, dt);
             break;
 
         case InputDeviceEnumerator::Mouse:
             if (handlers_[mouseIndex_s] != NULL)
-                handlers_[mouseIndex_s]->mouseUpdated(dt);
+                INPUT_STATE_PUSH_CALL(mouseIndex_s, mouseUpdated, dt);
             break;
 
         default: // joy sticks
             if (handlers_[device] != NULL)
-                handlers_[device]->joyStickUpdated(device - firstJoyStickIndex_s, dt);
+                INPUT_STATE_PUSH_CALL(device, joyStickUpdated, device - firstJoyStickIndex_s, dt);
             break;
         }
     }
 
-    template <typename EventType, class Traits>
-    FORCEINLINE void InputState::buttonEvent(unsigned int device, const typename Traits::ButtonTypeParam button)
+    template <typename EventType, class ButtonTypeParam>
+    FORCEINLINE void InputState::buttonEvent(unsigned int device, ButtonTypeParam button)
     {
         assert(device < handlers_.size());
         if (handlers_[device] != NULL)
-            handlers_[device]->buttonEvent(device, button, EventType());
+        {
+            // We have to store the function pointer to tell the compiler about its actual type because of overloading
+            void (InputHandler::*function)(unsigned int, ButtonTypeParam, EventType) = &InputHandler::buttonEvent<ButtonTypeParam>;
+            InputManager::getInstance().pushCall(boost::function<void ()>(boost::bind(function, handlers_[device], device, button, EventType())));
+        }
     }
 
@@ -233,5 +219,5 @@
     {
         if (handlers_[mouseIndex_s] != NULL)
-            handlers_[mouseIndex_s]->mouseMoved(abs, rel, clippingSize);
+            INPUT_STATE_PUSH_CALL(mouseIndex_s, mouseMoved, abs, rel, clippingSize);
     }
 
@@ -239,5 +225,5 @@
     {
         if (handlers_[mouseIndex_s] != NULL)
-            handlers_[mouseIndex_s]->mouseScrolled(abs, rel);
+            INPUT_STATE_PUSH_CALL(mouseIndex_s, mouseScrolled, abs, rel);
     }
 
@@ -246,5 +232,5 @@
         assert(device < handlers_.size());
         if (handlers_[device] != NULL)
-            handlers_[device]->axisMoved(device - firstJoyStickIndex_s, axis, value);
+            INPUT_STATE_PUSH_CALL(device, axisMoved, device - firstJoyStickIndex_s, axis, value);
     }
 }
Index: /code/trunk/src/libraries/network/TrafficControl.h
===================================================================
--- /code/trunk/src/libraries/network/TrafficControl.h	(revision 6745)
+++ /code/trunk/src/libraries/network/TrafficControl.h	(revision 6746)
@@ -34,5 +34,5 @@
 #include <list>
 #include <map>
-#include "network/ClientConnectionListener.h"
+#include "ClientConnectionListener.h"
 
 namespace orxonox {
Index: /code/trunk/src/libraries/util/Serialise.h
===================================================================
--- /code/trunk/src/libraries/util/Serialise.h	(revision 6745)
+++ /code/trunk/src/libraries/util/Serialise.h	(revision 6746)
@@ -35,7 +35,9 @@
 #define _Serialise_H__
 
+#include "UtilPrereqs.h"
+
 #include <cstring>
-#include "util/Math.h"
-#include "util/mbool.h"
+#include "Math.h"
+#include "mbool.h"
 
 namespace orxonox{
Index: /code/trunk/src/libraries/util/Singleton.h
===================================================================
--- /code/trunk/src/libraries/util/Singleton.h	(revision 6745)
+++ /code/trunk/src/libraries/util/Singleton.h	(revision 6746)
@@ -49,5 +49,5 @@
     public:
         //! Returns a reference to the singleton instance
-        static T& getInstance()
+        FORCEINLINE static T& getInstance()
         {
             assert(T::singletonPtr_s != NULL);
@@ -56,5 +56,5 @@
 
         //! Tells whether the singleton has been created
-        static bool exists()
+        FORCEINLINE static bool exists()
         {
             return (T::singletonPtr_s != NULL);
@@ -62,11 +62,11 @@
 
         //! Update method called by ClassSingletonManager (if used)
-        void preUpdateSingleton(const Clock& time) { static_cast<T*>(T::singletonPtr_s)->preUpdate(time); }
+        FORCEINLINE void preUpdateSingleton(const Clock& time) { static_cast<T*>(T::singletonPtr_s)->preUpdate(time); }
         //! Empty update method for the static polymorphism
-        void preUpdate(const Clock& time) { }
+        FORCEINLINE void preUpdate(const Clock& time) { }
         //! Update method called by ClassSingletonManager (if used)
-        void postUpdateSingleton(const Clock& time) { static_cast<T*>(T::singletonPtr_s)->postUpdate(time); }
+        FORCEINLINE void postUpdateSingleton(const Clock& time) { static_cast<T*>(T::singletonPtr_s)->postUpdate(time); }
         //! Empty update method for the static polymorphism
-        void postUpdate(const Clock& time) { }
+        FORCEINLINE void postUpdate(const Clock& time) { }
 
     protected:
Index: /code/trunk/src/libraries/util/TriBool.h
===================================================================
--- /code/trunk/src/libraries/util/TriBool.h	(revision 6746)
+++ /code/trunk/src/libraries/util/TriBool.h	(revision 6746)
@@ -0,0 +1,49 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _TriBool_H__
+#define _TriBool_H__
+
+#include "UtilPrereqs.h"
+
+// tolua_begin
+namespace orxonox
+{
+    namespace TriBool
+    {
+        enum Value
+        {
+            False    =  0,
+            True     =  1,
+            Dontcare =  2
+        };
+    }
+}
+// tolua_end
+
+#endif /* _TriBool_H__ */
Index: /code/trunk/src/modules/pickup/PickupManager.cc
===================================================================
--- /code/trunk/src/modules/pickup/PickupManager.cc	(revision 6745)
+++ /code/trunk/src/modules/pickup/PickupManager.cc	(revision 6746)
@@ -152,5 +152,5 @@
     PickupCarrier* PickupManager::getPawn(void)
     {
-        Pawn* pawn = dynamic_cast<Pawn*>(GUIManager::getInstancePtr()->getPlayer(PickupManager::guiName_s)->getControllableEntity());
+        Pawn* pawn = dynamic_cast<Pawn*>(GUIManager::getInstance().getPlayer(PickupManager::guiName_s)->getControllableEntity());
         if(pawn == NULL)
             return NULL;
Index: /code/trunk/src/modules/questsystem/QuestGUI.cc
===================================================================
--- /code/trunk/src/modules/questsystem/QuestGUI.cc	(revision 6745)
+++ /code/trunk/src/modules/questsystem/QuestGUI.cc	(revision 6746)
@@ -109,5 +109,5 @@
 
         //! Create root window.
-        this->rootWindow_ = this->windowManager_->createWindow("TaharezLook/ScrollablePane", "QuestGUI/Quests");
+        this->rootWindow_ = this->windowManager_->createWindow("MenuWidgets/ScrollablePane", "QuestGUI/Quests");
         this->rootWindow_->setSize(CEGUI::UVector2(CEGUI::UDim(1, 0),CEGUI::UDim(1, 0)));
 
@@ -161,7 +161,7 @@
         Get a CEGUI Window to use.
         Windows that are no longer used are collected with giveWindow, and are given out again with getWindow, so save some time recreating new windows everytime.
-        The retreived window is of type "TaharezLook/TabButton".
-    @return
-        Returns a CEGUI Window of type "TaharezLook/TabButton".
+        The retreived window is of type "MenuWidgets/TabButton".
+    @return
+        Returns a CEGUI Window of type "MenuWidgets/TabButton".
     */
     CEGUI::Window* QuestGUI::getWindow(void)
@@ -177,5 +177,5 @@
         std::ostringstream stream;
         stream << "QuestGUI/Quests/EmptyWindows/" << this->windows_.size()+1;
-        return this->windowManager_->createWindow("TaharezLook/TabButton", stream.str());
+        return this->windowManager_->createWindow("MenuWidgets/TabButton", stream.str());
     }
 
Index: /code/trunk/src/modules/questsystem/QuestGUINode.cc
===================================================================
--- /code/trunk/src/modules/questsystem/QuestGUINode.cc	(revision 6745)
+++ /code/trunk/src/modules/questsystem/QuestGUINode.cc	(revision 6746)
@@ -160,5 +160,5 @@
             stream << this->window_->getName() << "/Details";
             const QuestDescription* description = this->item_->getDescription();
-            this->details_ = this->gui_->getWindowManager()->createWindow("TaharezLook/FrameWindow", stream.str());
+            this->details_ = this->gui_->getWindowManager()->createWindow("MenuWidgets/FrameWindow", stream.str());
             this->details_->setSize(CEGUI::UVector2(CEGUI::UDim(0.7f, 0),CEGUI::UDim(0.7f, 0)));
             this->details_->setPosition(CEGUI::UVector2(CEGUI::UDim(0.1f, 0),CEGUI::UDim(0.1f, 0)));
@@ -171,5 +171,5 @@
             //! Create a ScrollablePane.
             stream << "/Scrollable";
-            CEGUI::Window* window = this->gui_->getWindowManager()->createWindow("TaharezLook/ScrollablePane", stream.str());
+            CEGUI::Window* window = this->gui_->getWindowManager()->createWindow("MenuWidgets/ScrollablePane", stream.str());
             window->setSize(CEGUI::UVector2(CEGUI::UDim(1.0, -2*QuestGUINode::BORDER_WIDTH),CEGUI::UDim(1.0, -QuestGUINode::TITLE_HEIGHT)));
             window->setPosition(CEGUI::UVector2(CEGUI::UDim(0, (float)QuestGUINode::BORDER_WIDTH),CEGUI::UDim(0, (float)QuestGUINode::TITLE_HEIGHT)));
@@ -185,5 +185,5 @@
                 stream.str("");
                 stream << this->details_->getName() << "/Status";
-                CEGUI::Window* statusWindow = this->gui_->getWindowManager()->createWindow("TaharezLook/StaticText", stream.str());
+                CEGUI::Window* statusWindow = this->gui_->getWindowManager()->createWindow("MenuWidgets/StaticText", stream.str());
                 window->addChildWindow(statusWindow);
                 std::string status;
@@ -214,5 +214,5 @@
             stream << this->details_->getName() << "/Description";
             stream << "/Title";
-            CEGUI::Window* descriptionWindowTitle = this->gui_->getWindowManager()->createWindow("TaharezLook/StaticText", stream.str());
+            CEGUI::Window* descriptionWindowTitle = this->gui_->getWindowManager()->createWindow("MenuWidgets/StaticText", stream.str());
             window->addChildWindow(descriptionWindowTitle);
             descriptionWindowTitle->setProperty("HorzFormatting", "HorzCentred");
@@ -227,5 +227,5 @@
             stream.str("");
             stream << this->details_->getName() << "/Description";
-            CEGUI::Window* descriptionWindow = this->gui_->getWindowManager()->createWindow("TaharezLook/StaticText", stream.str());
+            CEGUI::Window* descriptionWindow = this->gui_->getWindowManager()->createWindow("MenuWidgets/StaticText", stream.str());
             window->addChildWindow(descriptionWindow);
             descriptionWindow->setProperty("HorzFormatting", "WordWrapLeftAligned");
@@ -250,5 +250,5 @@
                             stream.str("");
                             stream << this->details_->getName() << "/Hints/Title";
-                            CEGUI::Window* hintsTitle = this->gui_->getWindowManager()->createWindow("TaharezLook/StaticText", stream.str());
+                            CEGUI::Window* hintsTitle = this->gui_->getWindowManager()->createWindow("MenuWidgets/StaticText", stream.str());
                             window->addChildWindow(hintsTitle);
                             hintsTitle->setProperty("HorzFormatting", "HorzCentred");
Index: /code/trunk/src/orxonox/CameraManager.h
===================================================================
--- /code/trunk/src/orxonox/CameraManager.h	(revision 6745)
+++ /code/trunk/src/orxonox/CameraManager.h	(revision 6746)
@@ -61,6 +61,4 @@
             void useCamera(Ogre::Camera* camera);
 
-            static CameraManager* getInstancePtr() { return singletonPtr_s; }
-
         private:
             CameraManager(const CameraManager&); // don't use
Index: /code/trunk/src/orxonox/Level.cc
===================================================================
--- /code/trunk/src/orxonox/Level.cc	(revision 6745)
+++ /code/trunk/src/orxonox/Level.cc	(revision 6746)
@@ -58,5 +58,5 @@
         if (this->isInitialized())
         {
-            if (LevelManager::getInstancePtr())
+            if (LevelManager::exists())
                 LevelManager::getInstance().releaseActivity(this);
 
@@ -116,5 +116,5 @@
             (*it)->setGametype(rootgametype);
 
-        if (LevelManager::getInstancePtr())
+        if (LevelManager::exists())
             LevelManager::getInstance().requestActivity(this);
     }
Index: /code/trunk/src/orxonox/LevelManager.h
===================================================================
--- /code/trunk/src/orxonox/LevelManager.h	(revision 6745)
+++ /code/trunk/src/orxonox/LevelManager.h	(revision 6746)
@@ -62,5 +62,4 @@
             const std::string& getAvailableLevelListItem(unsigned int index) const; //tolua_export
 
-            static LevelManager* getInstancePtr() { return singletonPtr_s; }
             static LevelManager& getInstance()    { return Singleton<LevelManager>::getInstance(); } // tolua_export
 
Index: /code/trunk/src/orxonox/PlayerManager.cc
===================================================================
--- /code/trunk/src/orxonox/PlayerManager.cc	(revision 6745)
+++ /code/trunk/src/orxonox/PlayerManager.cc	(revision 6746)
@@ -66,5 +66,5 @@
             this->clients_[clientID] = player;
 
-            if (LevelManager::getInstancePtr() && LevelManager::getInstance().getActiveLevel())
+            if (LevelManager::exists() && LevelManager::getInstance().getActiveLevel())
                 LevelManager::getInstance().getActiveLevel()->playerEntered(player);
         }
@@ -82,5 +82,5 @@
             this->clients_.erase(clientID);
 
-            if (LevelManager::getInstancePtr() && LevelManager::getInstance().getActiveLevel())
+            if (LevelManager::exists() && LevelManager::getInstance().getActiveLevel())
                 LevelManager::getInstance().getActiveLevel()->playerLeft(player);
 
Index: /code/trunk/src/orxonox/gamestates/GSLevel.cc
===================================================================
--- /code/trunk/src/orxonox/gamestates/GSLevel.cc	(revision 6745)
+++ /code/trunk/src/orxonox/gamestates/GSLevel.cc	(revision 6746)
@@ -69,14 +69,14 @@
         {
             gameInputState_ = InputManager::getInstance().createInputState("game");
-            gameInputState_->setMouseMode(MouseMode::Exclusive);
+            gameInputState_->setMouseExclusive(TriBool::True);
             gameInputState_->setHandler(KeyBinderManager::getInstance().getDefaultAsHandler());
             KeyBinderManager::getInstance().setToDefault();
 
             guiMouseOnlyInputState_ = InputManager::getInstance().createInputState("guiMouseOnly");
-            guiMouseOnlyInputState_->setMouseMode(MouseMode::Exclusive);
-            guiMouseOnlyInputState_->setMouseHandler(GUIManager::getInstancePtr());
+            guiMouseOnlyInputState_->setMouseExclusive(TriBool::True);
+            guiMouseOnlyInputState_->setMouseHandler(&GUIManager::getInstance());
 
             guiKeysOnlyInputState_ = InputManager::getInstance().createInputState("guiKeysOnly");
-            guiKeysOnlyInputState_->setKeyHandler(GUIManager::getInstancePtr());
+            guiKeysOnlyInputState_->setKeyHandler(&GUIManager::getInstance());
         }
 
Index: /code/trunk/src/orxonox/gamestates/GSMainMenu.cc
===================================================================
--- /code/trunk/src/orxonox/gamestates/GSMainMenu.cc	(revision 6745)
+++ /code/trunk/src/orxonox/gamestates/GSMainMenu.cc	(revision 6746)
@@ -31,6 +31,4 @@
 #include <OgreSceneManager.h>
 
-#include "core/input/InputManager.h"
-#include "core/input/InputState.h"
 #include "core/input/KeyBinderManager.h"
 #include "core/Game.h"
@@ -42,4 +40,7 @@
 #include "Scene.h"
 #include "sound/AmbientSound.h"
+// HACK
+#include "core/input/InputManager.h"
+#include "core/input/InputState.h"
 
 namespace orxonox
@@ -49,12 +50,8 @@
     GSMainMenu::GSMainMenu(const GameStateInfo& info)
         : GameState(info)
-        , inputState_(0)
     {
         RegisterRootObject(GSMainMenu);
-        inputState_ = InputManager::getInstance().createInputState("mainMenu");
-        inputState_->setMouseMode(MouseMode::Nonexclusive);
-        inputState_->setHandler(GUIManager::getInstancePtr());
-        inputState_->setKeyHandler(KeyBinderManager::getInstance().getDefaultAsHandler());
-        inputState_->setJoyStickHandler(&InputHandler::EMPTY);
+
+        InputManager::getInstance().createInputState("MainMenuHackery")->setKeyHandler(KeyBinderManager::getInstance().getDefaultAsHandler());
 
         // create an empty Scene
@@ -76,5 +73,5 @@
             this->ambient_->destroy();
 
-        InputManager::getInstance().destroyState("mainMenu");
+        InputManager::getInstance().destroyState("MainMenuHackery");
 
         this->scene_->getSceneManager()->destroyCamera(this->camera_);
@@ -85,9 +82,10 @@
     {
         // show main menu
-        GUIManager::getInstance().showGUI("MainMenu", true, GraphicsManager::getInstance().isFullScreen());
+        GUIManager::getInstance().showGUI("MainMenu", true);
         GUIManager::getInstance().setCamera(this->camera_);
-        GUIManager::getInstance().setBackground("MainMenuBackground");
-//         GUIManager::getInstance().setBackground("");
+        GUIManager::getInstance().setBackgroundImage("MainMenuBackground", "Background");
         GraphicsManager::getInstance().setCamera(this->camera_);
+
+        InputManager::getInstance().enterState("MainMenuHackery");
 
         CommandExecutor::addConsoleCommandShortcut(createConsoleCommand(createFunctor(&GSMainMenu::startStandalone), "startGame"));
@@ -101,5 +99,4 @@
 
         KeyBinderManager::getInstance().setToDefault();
-        InputManager::getInstance().enterState("mainMenu");
 
         this->setConfigValues();
@@ -119,8 +116,8 @@
         }
 
-        InputManager::getInstance().leaveState("mainMenu");
+        InputManager::getInstance().leaveState("MainMenuHackery");
 
         GUIManager::getInstance().setCamera(0);
-        GUIManager::getInstance().setBackground("");
+        GUIManager::getInstance().setBackgroundImage("");
         GUIManager::hideGUI("MainMenu");
         GraphicsManager::getInstance().setCamera(0);
Index: /code/trunk/src/orxonox/gamestates/GSMainMenu.h
===================================================================
--- /code/trunk/src/orxonox/gamestates/GSMainMenu.h	(revision 6745)
+++ /code/trunk/src/orxonox/gamestates/GSMainMenu.h	(revision 6746)
@@ -61,5 +61,4 @@
 
     private:
-        InputState*       inputState_;
         Scene*            scene_;
         Ogre::Camera*     camera_;
Index: /code/trunk/src/orxonox/overlays/CMakeLists.txt
===================================================================
--- /code/trunk/src/orxonox/overlays/CMakeLists.txt	(revision 6745)
+++ /code/trunk/src/orxonox/overlays/CMakeLists.txt	(revision 6746)
@@ -1,3 +1,4 @@
 ADD_SOURCE_FILES(ORXONOX_SRC_FILES
+  GUISheet.cc
   OrxonoxOverlay.cc
   OverlayGroup.cc
